<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="The Value enum, a loosely typed way of representing any valid JSON value."><meta name="keywords" content="rust, rustlang, rust-lang, value"><title>serde_json::value - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../serde_json/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../serde_json/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module value</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#reexports">Re-exports</a></li><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li><li><a href="#traits">Traits</a></li><li><a href="#functions">Functions</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../serde_json/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">serde_json</a>::<wbr><a class="mod" href="#">value</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/serde_json/value/mod.rs.html#1-989">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>The Value enum, a loosely typed way of representing any valid JSON value.</p>
<h2 id="constructing-json"><a href="#constructing-json">Constructing JSON</a></h2>
<p>Serde JSON provides a <a href="https://docs.serde.rs/serde_json/macro.json.html"><code>json!</code> macro</a> to build <code>serde_json::Value</code>
objects with very natural JSON syntax.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">serde_json::json</span>;

<span class="kw">fn</span> <span class="ident">main</span>() {
    <span class="comment">// The type of `john` is `serde_json::Value`</span>
    <span class="kw">let</span> <span class="ident">john</span> <span class="op">=</span> <span class="macro">json!</span>({
        <span class="string">&quot;name&quot;</span>: <span class="string">&quot;John Doe&quot;</span>,
        <span class="string">&quot;age&quot;</span>: <span class="number">43</span>,
        <span class="string">&quot;phones&quot;</span>: [
            <span class="string">&quot;+44 1234567&quot;</span>,
            <span class="string">&quot;+44 2345678&quot;</span>
        ]
    });

    <span class="macro">println!</span>(<span class="string">&quot;first phone number: {}&quot;</span>, <span class="ident">john</span>[<span class="string">&quot;phones&quot;</span>][<span class="number">0</span>]);

    <span class="comment">// Convert to a string of JSON and print it out</span>
    <span class="macro">println!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">john</span>.<span class="ident">to_string</span>());
}</code></pre></div>
<p>The <code>Value::to_string()</code> function converts a <code>serde_json::Value</code> into a
<code>String</code> of JSON text.</p>
<p>One neat thing about the <code>json!</code> macro is that variables and expressions can
be interpolated directly into the JSON value as you are building it. Serde
will check at compile time that the value you are interpolating is able to
be represented as JSON.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">let</span> <span class="ident">full_name</span> <span class="op">=</span> <span class="string">&quot;John Doe&quot;</span>;
<span class="kw">let</span> <span class="ident">age_last_year</span> <span class="op">=</span> <span class="number">42</span>;

<span class="comment">// The type of `john` is `serde_json::Value`</span>
<span class="kw">let</span> <span class="ident">john</span> <span class="op">=</span> <span class="macro">json!</span>({
    <span class="string">&quot;name&quot;</span>: <span class="ident">full_name</span>,
    <span class="string">&quot;age&quot;</span>: <span class="ident">age_last_year</span> <span class="op">+</span> <span class="number">1</span>,
    <span class="string">&quot;phones&quot;</span>: [
        <span class="macro">format!</span>(<span class="string">&quot;+44 {}&quot;</span>, <span class="ident">random_phone</span>())
    ]
});</code></pre></div>
<p>A string of JSON data can be parsed into a <code>serde_json::Value</code> by the
<a href="https://docs.serde.rs/serde_json/de/fn.from_str.html"><code>serde_json::from_str</code></a> function. There is also
<a href="https://docs.serde.rs/serde_json/de/fn.from_slice.html"><code>from_slice</code></a> for parsing from a byte slice <code>&amp;[u8]</code> and
<a href="https://docs.serde.rs/serde_json/de/fn.from_reader.html"><code>from_reader</code></a> for parsing from any <code>io::Read</code> like a File or
a TCP stream.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">serde_json</span>::{<span class="ident">json</span>, <span class="ident">Value</span>, <span class="ident">Error</span>};

<span class="kw">fn</span> <span class="ident">untyped_example</span>() -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="comment">// Some JSON input data as a &amp;str. Maybe this comes from the user.</span>
    <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="string">r#&quot;
        {
            &quot;name&quot;: &quot;John Doe&quot;,
            &quot;age&quot;: 43,
            &quot;phones&quot;: [
                &quot;+44 1234567&quot;,
                &quot;+44 2345678&quot;
            ]
        }&quot;#</span>;

    <span class="comment">// Parse the string of data into serde_json::Value.</span>
    <span class="kw">let</span> <span class="ident">v</span>: <span class="ident">Value</span> <span class="op">=</span> <span class="ident">serde_json::from_str</span>(<span class="ident">data</span>)<span class="question-mark">?</span>;

    <span class="comment">// Access parts of the data by indexing with square brackets.</span>
    <span class="macro">println!</span>(<span class="string">&quot;Please call {} at the number {}&quot;</span>, <span class="ident">v</span>[<span class="string">&quot;name&quot;</span>], <span class="ident">v</span>[<span class="string">&quot;phones&quot;</span>][<span class="number">0</span>]);

    <span class="prelude-val">Ok</span>(())
}</code></pre></div>
</div></details><h2 id="reexports" class="small-section-header"><a href="#reexports">Re-exports</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left import-item" id="reexport.Map"><code>pub use crate::map::<a class="struct" href="../struct.Map.html" title="struct serde_json::Map">Map</a>;</code></div><div class="item-right docblock-short"></div></div></div><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Number.html" title="serde_json::value::Number struct">Number</a></div><div class="item-right docblock-short"><p>Represents a JSON number, whether integer or floating point.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Serializer.html" title="serde_json::value::Serializer struct">Serializer</a></div><div class="item-right docblock-short"><p>Serializer whose output is a <code>Value</code>.</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Value.html" title="serde_json::value::Value enum">Value</a></div><div class="item-right docblock-short"><p>Represents any valid JSON value.</p>
</div></div></div><h2 id="traits" class="small-section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Index.html" title="serde_json::value::Index trait">Index</a></div><div class="item-right docblock-short"><p>A type that can be used to index into a <code>serde_json::Value</code>.</p>
</div></div></div><h2 id="functions" class="small-section-header"><a href="#functions">Functions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.from_value.html" title="serde_json::value::from_value fn">from_value</a></div><div class="item-right docblock-short"><p>Interpret a <code>serde_json::Value</code> as an instance of type <code>T</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.to_value.html" title="serde_json::value::to_value fn">to_value</a></div><div class="item-right docblock-short"><p>Convert a <code>T</code> into <code>serde_json::Value</code> which is an enum that can represent
any valid JSON data.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="serde_json" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>